=== removed file 'INSTALL'
--- INSTALL	2008-07-10 18:40:16 +0000
+++ INSTALL	1970-01-01 00:00:00 +0000
@@ -1,237 +0,0 @@
-Installation Instructions
-*************************
-
-Copyright (C) 1994, 1995, 1996, 1999, 2000, 2001, 2002, 2004, 2005,
-2006, 2007 Free Software Foundation, Inc.
-
-This file is free documentation; the Free Software Foundation gives
-unlimited permission to copy, distribute and modify it.
-
-Basic Installation
-==================
-
-Briefly, the shell commands `./configure; make; make install' should
-configure, build, and install this package.  The following
-more-detailed instructions are generic; see the `README' file for
-instructions specific to this package.
-
-   The `configure' shell script attempts to guess correct values for
-various system-dependent variables used during compilation.  It uses
-those values to create a `Makefile' in each directory of the package.
-It may also create one or more `.h' files containing system-dependent
-definitions.  Finally, it creates a shell script `config.status' that
-you can run in the future to recreate the current configuration, and a
-file `config.log' containing compiler output (useful mainly for
-debugging `configure').
-
-   It can also use an optional file (typically called `config.cache'
-and enabled with `--cache-file=config.cache' or simply `-C') that saves
-the results of its tests to speed up reconfiguring.  Caching is
-disabled by default to prevent problems with accidental use of stale
-cache files.
-
-   If you need to do unusual things to compile the package, please try
-to figure out how `configure' could check whether to do them, and mail
-diffs or instructions to the address given in the `README' so they can
-be considered for the next release.  If you are using the cache, and at
-some point `config.cache' contains results you don't want to keep, you
-may remove or edit it.
-
-   The file `configure.ac' (or `configure.in') is used to create
-`configure' by a program called `autoconf'.  You need `configure.ac' if
-you want to change it or regenerate `configure' using a newer version
-of `autoconf'.
-
-The simplest way to compile this package is:
-
-  1. `cd' to the directory containing the package's source code and type
-     `./configure' to configure the package for your system.
-
-     Running `configure' might take a while.  While running, it prints
-     some messages telling which features it is checking for.
-
-  2. Type `make' to compile the package.
-
-  3. Optionally, type `make check' to run any self-tests that come with
-     the package.
-
-  4. Type `make install' to install the programs and any data files and
-     documentation.
-
-  5. You can remove the program binaries and object files from the
-     source code directory by typing `make clean'.  To also remove the
-     files that `configure' created (so you can compile the package for
-     a different kind of computer), type `make distclean'.  There is
-     also a `make maintainer-clean' target, but that is intended mainly
-     for the package's developers.  If you use it, you may have to get
-     all sorts of other programs in order to regenerate files that came
-     with the distribution.
-
-  6. Often, you can also type `make uninstall' to remove the installed
-     files again.
-
-Compilers and Options
-=====================
-
-Some systems require unusual options for compilation or linking that the
-`configure' script does not know about.  Run `./configure --help' for
-details on some of the pertinent environment variables.
-
-   You can give `configure' initial values for configuration parameters
-by setting variables in the command line or in the environment.  Here
-is an example:
-
-     ./configure CC=c99 CFLAGS=-g LIBS=-lposix
-
-   *Note Defining Variables::, for more details.
-
-Compiling For Multiple Architectures
-====================================
-
-You can compile the package for more than one kind of computer at the
-same time, by placing the object files for each architecture in their
-own directory.  To do this, you can use GNU `make'.  `cd' to the
-directory where you want the object files and executables to go and run
-the `configure' script.  `configure' automatically checks for the
-source code in the directory that `configure' is in and in `..'.
-
-   With a non-GNU `make', it is safer to compile the package for one
-architecture at a time in the source code directory.  After you have
-installed the package for one architecture, use `make distclean' before
-reconfiguring for another architecture.
-
-Installation Names
-==================
-
-By default, `make install' installs the package's commands under
-`/usr/local/bin', include files under `/usr/local/include', etc.  You
-can specify an installation prefix other than `/usr/local' by giving
-`configure' the option `--prefix=PREFIX'.
-
-   You can specify separate installation prefixes for
-architecture-specific files and architecture-independent files.  If you
-pass the option `--exec-prefix=PREFIX' to `configure', the package uses
-PREFIX as the prefix for installing programs and libraries.
-Documentation and other data files still use the regular prefix.
-
-   In addition, if you use an unusual directory layout you can give
-options like `--bindir=DIR' to specify different values for particular
-kinds of files.  Run `configure --help' for a list of the directories
-you can set and what kinds of files go in them.
-
-   If the package supports it, you can cause programs to be installed
-with an extra prefix or suffix on their names by giving `configure' the
-option `--program-prefix=PREFIX' or `--program-suffix=SUFFIX'.
-
-Optional Features
-=================
-
-Some packages pay attention to `--enable-FEATURE' options to
-`configure', where FEATURE indicates an optional part of the package.
-They may also pay attention to `--with-PACKAGE' options, where PACKAGE
-is something like `gnu-as' or `x' (for the X Window System).  The
-`README' should mention any `--enable-' and `--with-' options that the
-package recognizes.
-
-   For packages that use the X Window System, `configure' can usually
-find the X include and library files automatically, but if it doesn't,
-you can use the `configure' options `--x-includes=DIR' and
-`--x-libraries=DIR' to specify their locations.
-
-Specifying the System Type
-==========================
-
-There may be some features `configure' cannot figure out automatically,
-but needs to determine by the type of machine the package will run on.
-Usually, assuming the package is built to be run on the _same_
-architectures, `configure' can figure that out, but if it prints a
-message saying it cannot guess the machine type, give it the
-`--build=TYPE' option.  TYPE can either be a short name for the system
-type, such as `sun4', or a canonical name which has the form:
-
-     CPU-COMPANY-SYSTEM
-
-where SYSTEM can have one of these forms:
-
-     OS KERNEL-OS
-
-   See the file `config.sub' for the possible values of each field.  If
-`config.sub' isn't included in this package, then this package doesn't
-need to know the machine type.
-
-   If you are _building_ compiler tools for cross-compiling, you should
-use the option `--target=TYPE' to select the type of system they will
-produce code for.
-
-   If you want to _use_ a cross compiler, that generates code for a
-platform different from the build platform, you should specify the
-"host" platform (i.e., that on which the generated programs will
-eventually be run) with `--host=TYPE'.
-
-Sharing Defaults
-================
-
-If you want to set default values for `configure' scripts to share, you
-can create a site shell script called `config.site' that gives default
-values for variables like `CC', `cache_file', and `prefix'.
-`configure' looks for `PREFIX/share/config.site' if it exists, then
-`PREFIX/etc/config.site' if it exists.  Or, you can set the
-`CONFIG_SITE' environment variable to the location of the site script.
-A warning: not all `configure' scripts look for a site script.
-
-Defining Variables
-==================
-
-Variables not defined in a site shell script can be set in the
-environment passed to `configure'.  However, some packages may run
-configure again during the build, and the customized values of these
-variables may be lost.  In order to avoid this problem, you should set
-them in the `configure' command line, using `VAR=value'.  For example:
-
-     ./configure CC=/usr/local2/bin/gcc
-
-causes the specified `gcc' to be used as the C compiler (unless it is
-overridden in the site shell script).
-
-Unfortunately, this technique does not work for `CONFIG_SHELL' due to
-an Autoconf bug.  Until the bug is fixed you can use this workaround:
-
-     CONFIG_SHELL=/bin/bash /bin/bash ./configure CONFIG_SHELL=/bin/bash
-
-`configure' Invocation
-======================
-
-`configure' recognizes the following options to control how it operates.
-
-`--help'
-`-h'
-     Print a summary of the options to `configure', and exit.
-
-`--version'
-`-V'
-     Print the version of Autoconf used to generate the `configure'
-     script, and exit.
-
-`--cache-file=FILE'
-     Enable the cache: use and save the results of the tests in FILE,
-     traditionally `config.cache'.  FILE defaults to `/dev/null' to
-     disable caching.
-
-`--config-cache'
-`-C'
-     Alias for `--cache-file=config.cache'.
-
-`--quiet'
-`--silent'
-`-q'
-     Do not print messages saying which checks are being made.  To
-     suppress all normal output, redirect it to `/dev/null' (any error
-     messages will still be shown).
-
-`--srcdir=DIR'
-     Look for the package's source code in directory DIR.  Usually
-     `configure' can determine that directory automatically.
-
-`configure' also accepts some other, not widely useful, options.  Run
-`configure --help' for more details.
-

=== modified file 'include/mysql/plugin.h'
--- include/mysql/plugin.h	2008-07-09 15:52:52 +0000
+++ include/mysql/plugin.h	2008-07-12 07:25:25 +0000
@@ -427,6 +427,24 @@
 
 
 /*************************************************************************
+  API for UDF plugin. (MYSQL_UDF_PLUGIN)
+*/
+
+/* handlertons of different MySQL releases are incompatible */
+#define MYSQL_UDF_INTERFACE_VERSION (MYSQL_VERSION_ID << 8)
+
+/*
+  Here we define only the descriptor structure, that is referred from
+  st_mysql_plugin.
+*/
+
+struct st_mysql_udf
+{
+  int interface_version;
+};
+
+
+/*************************************************************************
   API for I_S plugin. (MYSQL_INFORMATION_SCHEMA_PLUGIN)
 */
 

=== modified file 'plugin/Makefile.am'
--- plugin/Makefile.am	2008-07-01 21:55:08 +0000
+++ plugin/Makefile.am	2008-07-12 07:25:25 +0000
@@ -22,4 +22,4 @@
 #EXTRA_DIST =	fulltext/configure.in	
 
 SUBDIRS =	@mysql_pg_dirs@
-DIST_SUBDIRS =	
+DIST_SUBDIRS =	hello_world

=== added directory 'plugin/hello_world'
=== added file 'plugin/hello_world/AUTHORS'
--- plugin/hello_world/AUTHORS	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/AUTHORS	2008-07-12 11:37:59 +0000
@@ -0,0 +1,2 @@
+Mark Atwood <mark@fallenpegasus.com>
+

=== added file 'plugin/hello_world/ChangeLog'
--- plugin/hello_world/ChangeLog	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/ChangeLog	2008-07-12 11:37:59 +0000
@@ -0,0 +1,2 @@
+0.1
+  - Added

=== added file 'plugin/hello_world/Makefile.am'
--- plugin/hello_world/Makefile.am	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/Makefile.am	2008-07-12 11:37:59 +0000
@@ -0,0 +1,38 @@
+# Copyright (C) 2006 MySQL AB
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+#Makefile.am example for a Hello World
+MYSQLDATAdir =          $(localstatedir)
+MYSQLSHAREdir =         $(pkgdatadir)
+MYSQLBASEdir=           $(prefix)
+MYSQLLIBdir=            $(pkglibdir)
+pkgplugindir =		$(pkglibdir)/plugin
+INCLUDES =              -I$(top_srcdir)/include -I$(top_builddir)/include \
+			-I$(top_srcdir)/server \
+                        -I$(srcdir)
+
+EXTRA_LTLIBRARIES =	libhello_world.la
+pkgplugin_LTLIBRARIES =	@plugin_hello_world_shared_target@
+libhello_world_la_LDFLAGS =	-module -rpath $(pkgplugindir)
+libhello_world_la_CXXFLAGS=	$(AM_CFLAGS) -DMYSQL_DYNAMIC_PLUGIN
+libhello_world_la_CFLAGS =	$(AM_CFLAGS) -DMYSQL_DYNAMIC_PLUGIN
+libhello_world_la_SOURCES =	hello_world.cc
+
+
+EXTRA_LIBRARIES =	libhello_world.a
+noinst_LIBRARIES =	@plugin_hello_world_static_target@
+libhello_world_a_CXXFLAGS =	$(AM_CFLAGS)
+libhello_world_a_CFLAGS =	$(AM_CFLAGS)
+libhello_world_a_SOURCES=	hello_world.cc

=== added file 'plugin/hello_world/Makefile.in'
--- plugin/hello_world/Makefile.in	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/Makefile.in	2008-07-12 11:37:59 +0000
@@ -0,0 +1,649 @@
+# Makefile.in generated by automake 1.10 from Makefile.am.
+# @configure_input@
+
+# Copyright (C) 1994, 1995, 1996, 1997, 1998, 1999, 2000, 2001, 2002,
+# 2003, 2004, 2005, 2006  Free Software Foundation, Inc.
+# This Makefile.in is free software; the Free Software Foundation
+# gives unlimited permission to copy and/or distribute it,
+# with or without modifications, as long as this notice is preserved.
+
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY, to the extent permitted by law; without
+# even the implied warranty of MERCHANTABILITY or FITNESS FOR A
+# PARTICULAR PURPOSE.
+
+@SET_MAKE@
+
+# Copyright (C) 2006 MySQL AB
+#
+# This program is free software; you can redistribute it and/or modify
+# it under the terms of the GNU General Public License as published by
+# the Free Software Foundation; version 2 of the License.
+#
+# This program is distributed in the hope that it will be useful,
+# but WITHOUT ANY WARRANTY; without even the implied warranty of
+# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+# GNU General Public License for more details.
+#
+# You should have received a copy of the GNU General Public License
+# along with this program; if not, write to the Free Software
+# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
+
+
+VPATH = @srcdir@
+pkgdatadir = $(datadir)/@PACKAGE@
+pkglibdir = $(libdir)/@PACKAGE@
+pkgincludedir = $(includedir)/@PACKAGE@
+am__cd = CDPATH="$${ZSH_VERSION+.}$(PATH_SEPARATOR)" && cd
+install_sh_DATA = $(install_sh) -c -m 644
+install_sh_PROGRAM = $(install_sh) -c
+install_sh_SCRIPT = $(install_sh) -c
+INSTALL_HEADER = $(INSTALL_DATA)
+transform = $(program_transform_name)
+NORMAL_INSTALL = :
+PRE_INSTALL = :
+POST_INSTALL = :
+NORMAL_UNINSTALL = :
+PRE_UNINSTALL = :
+POST_UNINSTALL = :
+build_triplet = @build@
+host_triplet = @host@
+target_triplet = @target@
+subdir = plugin/hello_world
+DIST_COMMON = $(srcdir)/Makefile.am $(srcdir)/Makefile.in AUTHORS \
+	ChangeLog
+ACLOCAL_M4 = $(top_srcdir)/aclocal.m4
+am__aclocal_m4_deps = $(top_srcdir)/config/ac-macros/alloca.m4 \
+	$(top_srcdir)/config/ac-macros/check_cpu.m4 \
+	$(top_srcdir)/config/ac-macros/character_sets.m4 \
+	$(top_srcdir)/config/ac-macros/compiler_flag.m4 \
+	$(top_srcdir)/config/ac-macros/dtrace.m4 \
+	$(top_srcdir)/config/ac-macros/plugins.m4 \
+	$(top_srcdir)/config/ac-macros/large_file.m4 \
+	$(top_srcdir)/config/ac-macros/misc.m4 \
+	$(top_srcdir)/config/ac-macros/readline.m4 \
+	$(top_srcdir)/config/ac-macros/pkg.m4 \
+	$(top_srcdir)/configure.ac
+am__configure_deps = $(am__aclocal_m4_deps) $(CONFIGURE_DEPENDENCIES) \
+	$(ACLOCAL_M4)
+mkinstalldirs = $(install_sh) -d
+CONFIG_HEADER = $(top_builddir)/include/config.h
+CONFIG_CLEAN_FILES =
+LIBRARIES = $(noinst_LIBRARIES)
+libhello_world_a_AR = $(AR) $(ARFLAGS)
+libhello_world_a_LIBADD =
+am_libhello_world_a_OBJECTS = libhello_world_a-hello_world.$(OBJEXT)
+libhello_world_a_OBJECTS = $(am_libhello_world_a_OBJECTS)
+am__vpath_adj_setup = srcdirstrip=`echo "$(srcdir)" | sed 's|.|.|g'`;
+am__vpath_adj = case $$p in \
+    $(srcdir)/*) f=`echo "$$p" | sed "s|^$$srcdirstrip/||"`;; \
+    *) f=$$p;; \
+  esac;
+am__strip_dir = `echo $$p | sed -e 's|^.*/||'`;
+am__installdirs = "$(DESTDIR)$(pkgplugindir)"
+pkgpluginLTLIBRARIES_INSTALL = $(INSTALL)
+LTLIBRARIES = $(pkgplugin_LTLIBRARIES)
+libhello_world_la_LIBADD =
+am_libhello_world_la_OBJECTS = libhello_world_la-hello_world.lo
+libhello_world_la_OBJECTS = $(am_libhello_world_la_OBJECTS)
+libhello_world_la_LINK = $(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) \
+	$(LIBTOOLFLAGS) --mode=link $(CXXLD) \
+	$(libhello_world_la_CXXFLAGS) $(CXXFLAGS) \
+	$(libhello_world_la_LDFLAGS) $(LDFLAGS) -o $@
+DEFAULT_INCLUDES = -I. -I$(top_builddir)/include@am__isrc@
+depcomp = $(SHELL) $(top_srcdir)/config/depcomp
+am__depfiles_maybe = depfiles
+CXXCOMPILE = $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) \
+	$(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS)
+LTCXXCOMPILE = $(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) \
+	--mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) \
+	$(AM_CPPFLAGS) $(CPPFLAGS) $(AM_CXXFLAGS) $(CXXFLAGS)
+CXXLD = $(CXX)
+CXXLINK = $(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) \
+	--mode=link $(CXXLD) $(AM_CXXFLAGS) $(CXXFLAGS) $(AM_LDFLAGS) \
+	$(LDFLAGS) -o $@
+SOURCES = $(libhello_world_a_SOURCES) $(libhello_world_la_SOURCES)
+DIST_SOURCES = $(libhello_world_a_SOURCES) \
+	$(libhello_world_la_SOURCES)
+ETAGS = etags
+CTAGS = ctags
+DISTFILES = $(DIST_COMMON) $(DIST_SOURCES) $(TEXINFOS) $(EXTRA_DIST)
+ACLOCAL = @ACLOCAL@
+ALLOCA = @ALLOCA@
+AMTAR = @AMTAR@
+AR = @AR@
+ARFLAGS = @ARFLAGS@
+AS = @AS@
+ASFLAGS = @ASFLAGS@
+AUTOCONF = @AUTOCONF@
+AUTOHEADER = @AUTOHEADER@
+AUTOMAKE = @AUTOMAKE@
+AVAILABLE_LANGUAGES = @AVAILABLE_LANGUAGES@
+AWK = @AWK@
+CC = @CC@
+CCAS = @CCAS@
+CCASDEPMODE = @CCASDEPMODE@
+CCASFLAGS = @CCASFLAGS@
+CCDEPMODE = @CCDEPMODE@
+CC_VERSION = @CC_VERSION@
+CFLAGS = @CFLAGS@
+CHECK_PID = @CHECK_PID@
+CHMOD = @CHMOD@
+CMP = @CMP@
+COMPILATION_COMMENT = @COMPILATION_COMMENT@
+CONF_COMMAND = @CONF_COMMAND@
+CP = @CP@
+CPP = @CPP@
+CPPFLAGS = @CPPFLAGS@
+CXX = @CXX@
+CXXCPP = @CXXCPP@
+CXXDEPMODE = @CXXDEPMODE@
+CXXFLAGS = @CXXFLAGS@
+CXXLDFLAGS = @CXXLDFLAGS@
+CXX_VERSION = @CXX_VERSION@
+CYGPATH_W = @CYGPATH_W@
+DEFS = @DEFS@
+DEPDIR = @DEPDIR@
+DOT_FRM_VERSION = @DOT_FRM_VERSION@
+DTRACE = @DTRACE@
+DTRACEFLAGS = @DTRACEFLAGS@
+ECHO = @ECHO@
+ECHO_C = @ECHO_C@
+ECHO_N = @ECHO_N@
+ECHO_T = @ECHO_T@
+EGREP = @EGREP@
+EXEEXT = @EXEEXT@
+F77 = @F77@
+FFLAGS = @FFLAGS@
+FIND_PROC = @FIND_PROC@
+GETCONF = @GETCONF@
+GREP = @GREP@
+GXX = @GXX@
+HAVE_DTRACE = @HAVE_DTRACE@
+HOSTNAME = @HOSTNAME@
+ICHECK = @ICHECK@
+INSTALL = @INSTALL@
+INSTALL_DATA = @INSTALL_DATA@
+INSTALL_PROGRAM = @INSTALL_PROGRAM@
+INSTALL_SCRIPT = @INSTALL_SCRIPT@
+INSTALL_STRIP_PROGRAM = @INSTALL_STRIP_PROGRAM@
+KILL = @KILL@
+LD = @LD@
+LDFLAGS = @LDFLAGS@
+LD_VERSION_SCRIPT = @LD_VERSION_SCRIPT@
+LIBDL = @LIBDL@
+LIBOBJS = @LIBOBJS@
+LIBS = @LIBS@
+LIBTOOL = @LIBTOOL@
+LN = @LN@
+LN_CP_F = @LN_CP_F@
+LN_S = @LN_S@
+LTLIBOBJS = @LTLIBOBJS@
+MACHINE_TYPE = @MACHINE_TYPE@
+MAKEINFO = @MAKEINFO@
+MAKE_BINARY_DISTRIBUTION_OPTIONS = @MAKE_BINARY_DISTRIBUTION_OPTIONS@
+MAKE_SHELL = @MAKE_SHELL@
+MKDIR_P = @MKDIR_P@
+MV = @MV@
+MYSQLD_DEFAULT_SWITCHES = @MYSQLD_DEFAULT_SWITCHES@
+MYSQLD_USER = @MYSQLD_USER@
+MYSQL_BASE_VERSION = @MYSQL_BASE_VERSION@
+MYSQL_NO_DASH_VERSION = @MYSQL_NO_DASH_VERSION@
+MYSQL_PREVIOUS_BASE_VERSION = @MYSQL_PREVIOUS_BASE_VERSION@
+MYSQL_SERVER_SUFFIX = @MYSQL_SERVER_SUFFIX@
+MYSQL_TCP_PORT = @MYSQL_TCP_PORT@
+MYSQL_TCP_PORT_DEFAULT = @MYSQL_TCP_PORT_DEFAULT@
+MYSQL_VERSION_ID = @MYSQL_VERSION_ID@
+NM = @NM@
+OBJEXT = @OBJEXT@
+PACKAGE = @PACKAGE@
+PACKAGE_BUGREPORT = @PACKAGE_BUGREPORT@
+PACKAGE_NAME = @PACKAGE_NAME@
+PACKAGE_STRING = @PACKAGE_STRING@
+PACKAGE_TARNAME = @PACKAGE_TARNAME@
+PACKAGE_VERSION = @PACKAGE_VERSION@
+PATH_SEPARATOR = @PATH_SEPARATOR@
+PCRE_CFLAGS = @PCRE_CFLAGS@
+PCRE_LIBS = @PCRE_LIBS@
+PERL = @PERL@
+PERL5 = @PERL5@
+PKG_CONFIG = @PKG_CONFIG@
+PROTOCOL_VERSION = @PROTOCOL_VERSION@
+PS = @PS@
+RANLIB = @RANLIB@
+RM = @RM@
+SAVE_ASFLAGS = @SAVE_ASFLAGS@
+SAVE_CC = @SAVE_CC@
+SAVE_CFLAGS = @SAVE_CFLAGS@
+SAVE_CXX = @SAVE_CXX@
+SAVE_CXXFLAGS = @SAVE_CXXFLAGS@
+SAVE_CXXLDFLAGS = @SAVE_CXXLDFLAGS@
+SAVE_LDFLAGS = @SAVE_LDFLAGS@
+SED = @SED@
+SET_MAKE = @SET_MAKE@
+SHARED_LIB_MAJOR_VERSION = @SHARED_LIB_MAJOR_VERSION@
+SHARED_LIB_VERSION = @SHARED_LIB_VERSION@
+SHELL = @SHELL@
+STRIP = @STRIP@
+SYSTEM_TYPE = @SYSTEM_TYPE@
+TAR = @TAR@
+TARGET_LINUX = @TARGET_LINUX@
+TARGET_SOLARIS = @TARGET_SOLARIS@
+TERMCAP_LIB = @TERMCAP_LIB@
+VERSION = @VERSION@
+YACC = @YACC@
+abs_builddir = @abs_builddir@
+abs_srcdir = @abs_srcdir@
+abs_top_builddir = @abs_top_builddir@
+abs_top_srcdir = @abs_top_srcdir@
+ac_ct_CC = @ac_ct_CC@
+ac_ct_CXX = @ac_ct_CXX@
+ac_ct_F77 = @ac_ct_F77@
+am__include = @am__include@
+am__leading_dot = @am__leading_dot@
+am__quote = @am__quote@
+am__tar = @am__tar@
+am__untar = @am__untar@
+bindir = @bindir@
+build = @build@
+build_alias = @build_alias@
+build_cpu = @build_cpu@
+build_os = @build_os@
+build_vendor = @build_vendor@
+builddir = @builddir@
+condition_dependent_plugin_includes = @condition_dependent_plugin_includes@
+condition_dependent_plugin_links = @condition_dependent_plugin_links@
+condition_dependent_plugin_modules = @condition_dependent_plugin_modules@
+condition_dependent_plugin_objects = @condition_dependent_plugin_objects@
+datadir = @datadir@
+datarootdir = @datarootdir@
+docdir = @docdir@
+dvidir = @dvidir@
+exec_prefix = @exec_prefix@
+host = @host@
+host_alias = @host_alias@
+host_cpu = @host_cpu@
+host_os = @host_os@
+host_vendor = @host_vendor@
+htmldir = @htmldir@
+includedir = @includedir@
+infodir = @infodir@
+innodb_system_libs = @innodb_system_libs@
+install_sh = @install_sh@
+libdir = @libdir@
+libexecdir = @libexecdir@
+localedir = @localedir@
+localstatedir = @localstatedir@
+mandir = @mandir@
+mkdir_p = @mkdir_p@
+mysql_pg_dirs = @mysql_pg_dirs@
+mysql_pg_unittest_dirs = @mysql_pg_unittest_dirs@
+mysql_plugin_defs = @mysql_plugin_defs@
+mysql_plugin_dirs = @mysql_plugin_dirs@
+mysql_plugin_libs = @mysql_plugin_libs@
+mysql_se_dirs = @mysql_se_dirs@
+mysql_se_unittest_dirs = @mysql_se_unittest_dirs@
+oldincludedir = @oldincludedir@
+pdfdir = @pdfdir@
+plugin_archive_shared_target = @plugin_archive_shared_target@
+plugin_archive_static_target = @plugin_archive_static_target@
+plugin_blackhole_shared_target = @plugin_blackhole_shared_target@
+plugin_blackhole_static_target = @plugin_blackhole_static_target@
+plugin_csv_shared_target = @plugin_csv_shared_target@
+plugin_csv_static_target = @plugin_csv_static_target@
+plugin_heap_shared_target = @plugin_heap_shared_target@
+plugin_heap_static_target = @plugin_heap_static_target@
+plugin_hello_world_shared_target = @plugin_hello_world_shared_target@
+plugin_hello_world_static_target = @plugin_hello_world_static_target@
+plugin_innobase_shared_target = @plugin_innobase_shared_target@
+plugin_innobase_static_target = @plugin_innobase_static_target@
+plugin_myisam_shared_target = @plugin_myisam_shared_target@
+plugin_myisam_static_target = @plugin_myisam_static_target@
+prefix = @prefix@
+program_transform_name = @program_transform_name@
+psdir = @psdir@
+sbindir = @sbindir@
+sharedstatedir = @sharedstatedir@
+srcdir = @srcdir@
+sysconfdir = @sysconfdir@
+target = @target@
+target_alias = @target_alias@
+target_cpu = @target_cpu@
+target_os = @target_os@
+target_vendor = @target_vendor@
+top_builddir = @top_builddir@
+top_srcdir = @top_srcdir@
+uname_prog = @uname_prog@
+
+#Makefile.am example for a Hello World
+MYSQLDATAdir = $(localstatedir)
+MYSQLSHAREdir = $(pkgdatadir)
+MYSQLBASEdir = $(prefix)
+MYSQLLIBdir = $(pkglibdir)
+pkgplugindir = $(pkglibdir)/plugin
+INCLUDES = -I$(top_srcdir)/include -I$(top_builddir)/include \
+			-I$(top_srcdir)/server \
+                        -I$(srcdir)
+
+EXTRA_LTLIBRARIES = libhello_world.la
+pkgplugin_LTLIBRARIES = @plugin_hello_world_shared_target@
+libhello_world_la_LDFLAGS = -module -rpath $(pkgplugindir)
+libhello_world_la_CXXFLAGS = $(AM_CFLAGS) -DMYSQL_DYNAMIC_PLUGIN
+libhello_world_la_CFLAGS = $(AM_CFLAGS) -DMYSQL_DYNAMIC_PLUGIN
+libhello_world_la_SOURCES = hello_world.cc
+EXTRA_LIBRARIES = libhello_world.a
+noinst_LIBRARIES = @plugin_hello_world_static_target@
+libhello_world_a_CXXFLAGS = $(AM_CFLAGS)
+libhello_world_a_CFLAGS = $(AM_CFLAGS)
+libhello_world_a_SOURCES = hello_world.cc
+all: all-am
+
+.SUFFIXES:
+.SUFFIXES: .cc .lo .o .obj
+$(srcdir)/Makefile.in:  $(srcdir)/Makefile.am  $(am__configure_deps)
+	@for dep in $?; do \
+	  case '$(am__configure_deps)' in \
+	    *$$dep*) \
+	      cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh \
+		&& exit 0; \
+	      exit 1;; \
+	  esac; \
+	done; \
+	echo ' cd $(top_srcdir) && $(AUTOMAKE) --gnu  plugin/hello_world/Makefile'; \
+	cd $(top_srcdir) && \
+	  $(AUTOMAKE) --gnu  plugin/hello_world/Makefile
+.PRECIOUS: Makefile
+Makefile: $(srcdir)/Makefile.in $(top_builddir)/config.status
+	@case '$?' in \
+	  *config.status*) \
+	    cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh;; \
+	  *) \
+	    echo ' cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe)'; \
+	    cd $(top_builddir) && $(SHELL) ./config.status $(subdir)/$@ $(am__depfiles_maybe);; \
+	esac;
+
+$(top_builddir)/config.status: $(top_srcdir)/configure $(CONFIG_STATUS_DEPENDENCIES)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+
+$(top_srcdir)/configure:  $(am__configure_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+$(ACLOCAL_M4):  $(am__aclocal_m4_deps)
+	cd $(top_builddir) && $(MAKE) $(AM_MAKEFLAGS) am--refresh
+
+clean-noinstLIBRARIES:
+	-test -z "$(noinst_LIBRARIES)" || rm -f $(noinst_LIBRARIES)
+libhello_world.a: $(libhello_world_a_OBJECTS) $(libhello_world_a_DEPENDENCIES) 
+	-rm -f libhello_world.a
+	$(libhello_world_a_AR) libhello_world.a $(libhello_world_a_OBJECTS) $(libhello_world_a_LIBADD)
+	$(RANLIB) libhello_world.a
+install-pkgpluginLTLIBRARIES: $(pkgplugin_LTLIBRARIES)
+	@$(NORMAL_INSTALL)
+	test -z "$(pkgplugindir)" || $(MKDIR_P) "$(DESTDIR)$(pkgplugindir)"
+	@list='$(pkgplugin_LTLIBRARIES)'; for p in $$list; do \
+	  if test -f $$p; then \
+	    f=$(am__strip_dir) \
+	    echo " $(LIBTOOL) --mode=install $(pkgpluginLTLIBRARIES_INSTALL) $(INSTALL_STRIP_FLAG) '$$p' '$(DESTDIR)$(pkgplugindir)/$$f'"; \
+	    $(LIBTOOL) --mode=install $(pkgpluginLTLIBRARIES_INSTALL) $(INSTALL_STRIP_FLAG) "$$p" "$(DESTDIR)$(pkgplugindir)/$$f"; \
+	  else :; fi; \
+	done
+
+uninstall-pkgpluginLTLIBRARIES:
+	@$(NORMAL_UNINSTALL)
+	@list='$(pkgplugin_LTLIBRARIES)'; for p in $$list; do \
+	  p=$(am__strip_dir) \
+	  echo " $(LIBTOOL) --mode=uninstall rm -f '$(DESTDIR)$(pkgplugindir)/$$p'"; \
+	  $(LIBTOOL) --mode=uninstall rm -f "$(DESTDIR)$(pkgplugindir)/$$p"; \
+	done
+
+clean-pkgpluginLTLIBRARIES:
+	-test -z "$(pkgplugin_LTLIBRARIES)" || rm -f $(pkgplugin_LTLIBRARIES)
+	@list='$(pkgplugin_LTLIBRARIES)'; for p in $$list; do \
+	  dir="`echo $$p | sed -e 's|/[^/]*$$||'`"; \
+	  test "$$dir" != "$$p" || dir=.; \
+	  echo "rm -f \"$${dir}/so_locations\""; \
+	  rm -f "$${dir}/so_locations"; \
+	done
+libhello_world.la: $(libhello_world_la_OBJECTS) $(libhello_world_la_DEPENDENCIES) 
+	$(libhello_world_la_LINK)  $(libhello_world_la_OBJECTS) $(libhello_world_la_LIBADD) $(LIBS)
+
+mostlyclean-compile:
+	-rm -f *.$(OBJEXT)
+
+distclean-compile:
+	-rm -f *.tab.c
+
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libhello_world_a-hello_world.Po@am__quote@
+@AMDEP_TRUE@@am__include@ @am__quote@./$(DEPDIR)/libhello_world_la-hello_world.Plo@am__quote@
+
+.cc.o:
+@am__fastdepCXX_TRUE@	$(CXXCOMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXXCOMPILE) -c -o $@ $<
+
+.cc.obj:
+@am__fastdepCXX_TRUE@	$(CXXCOMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ `$(CYGPATH_W) '$<'`
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$<' object='$@' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXXCOMPILE) -c -o $@ `$(CYGPATH_W) '$<'`
+
+.cc.lo:
+@am__fastdepCXX_TRUE@	$(LTCXXCOMPILE) -MT $@ -MD -MP -MF $(DEPDIR)/$*.Tpo -c -o $@ $<
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/$*.Tpo $(DEPDIR)/$*.Plo
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='$<' object='$@' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(LTCXXCOMPILE) -c -o $@ $<
+
+libhello_world_a-hello_world.o: hello_world.cc
+@am__fastdepCXX_TRUE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_a_CXXFLAGS) $(CXXFLAGS) -MT libhello_world_a-hello_world.o -MD -MP -MF $(DEPDIR)/libhello_world_a-hello_world.Tpo -c -o libhello_world_a-hello_world.o `test -f 'hello_world.cc' || echo '$(srcdir)/'`hello_world.cc
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libhello_world_a-hello_world.Tpo $(DEPDIR)/libhello_world_a-hello_world.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='hello_world.cc' object='libhello_world_a-hello_world.o' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_a_CXXFLAGS) $(CXXFLAGS) -c -o libhello_world_a-hello_world.o `test -f 'hello_world.cc' || echo '$(srcdir)/'`hello_world.cc
+
+libhello_world_a-hello_world.obj: hello_world.cc
+@am__fastdepCXX_TRUE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_a_CXXFLAGS) $(CXXFLAGS) -MT libhello_world_a-hello_world.obj -MD -MP -MF $(DEPDIR)/libhello_world_a-hello_world.Tpo -c -o libhello_world_a-hello_world.obj `if test -f 'hello_world.cc'; then $(CYGPATH_W) 'hello_world.cc'; else $(CYGPATH_W) '$(srcdir)/hello_world.cc'; fi`
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libhello_world_a-hello_world.Tpo $(DEPDIR)/libhello_world_a-hello_world.Po
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='hello_world.cc' object='libhello_world_a-hello_world.obj' libtool=no @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_a_CXXFLAGS) $(CXXFLAGS) -c -o libhello_world_a-hello_world.obj `if test -f 'hello_world.cc'; then $(CYGPATH_W) 'hello_world.cc'; else $(CYGPATH_W) '$(srcdir)/hello_world.cc'; fi`
+
+libhello_world_la-hello_world.lo: hello_world.cc
+@am__fastdepCXX_TRUE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_la_CXXFLAGS) $(CXXFLAGS) -MT libhello_world_la-hello_world.lo -MD -MP -MF $(DEPDIR)/libhello_world_la-hello_world.Tpo -c -o libhello_world_la-hello_world.lo `test -f 'hello_world.cc' || echo '$(srcdir)/'`hello_world.cc
+@am__fastdepCXX_TRUE@	mv -f $(DEPDIR)/libhello_world_la-hello_world.Tpo $(DEPDIR)/libhello_world_la-hello_world.Plo
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	source='hello_world.cc' object='libhello_world_la-hello_world.lo' libtool=yes @AMDEPBACKSLASH@
+@AMDEP_TRUE@@am__fastdepCXX_FALSE@	DEPDIR=$(DEPDIR) $(CXXDEPMODE) $(depcomp) @AMDEPBACKSLASH@
+@am__fastdepCXX_FALSE@	$(LIBTOOL) --tag=CXX $(AM_LIBTOOLFLAGS) $(LIBTOOLFLAGS) --mode=compile $(CXX) $(DEFS) $(DEFAULT_INCLUDES) $(INCLUDES) $(AM_CPPFLAGS) $(CPPFLAGS) $(libhello_world_la_CXXFLAGS) $(CXXFLAGS) -c -o libhello_world_la-hello_world.lo `test -f 'hello_world.cc' || echo '$(srcdir)/'`hello_world.cc
+
+mostlyclean-libtool:
+	-rm -f *.lo
+
+clean-libtool:
+	-rm -rf .libs _libs
+
+ID: $(HEADERS) $(SOURCES) $(LISP) $(TAGS_FILES)
+	list='$(SOURCES) $(HEADERS) $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '    { files[$$0] = 1; } \
+	       END { for (i in files) print i; }'`; \
+	mkid -fID $$unique
+tags: TAGS
+
+TAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
+		$(TAGS_FILES) $(LISP)
+	tags=; \
+	here=`pwd`; \
+	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '    { files[$$0] = 1; } \
+	       END { for (i in files) print i; }'`; \
+	if test -z "$(ETAGS_ARGS)$$tags$$unique"; then :; else \
+	  test -n "$$unique" || unique=$$empty_fix; \
+	  $(ETAGS) $(ETAGSFLAGS) $(AM_ETAGSFLAGS) $(ETAGS_ARGS) \
+	    $$tags $$unique; \
+	fi
+ctags: CTAGS
+CTAGS:  $(HEADERS) $(SOURCES)  $(TAGS_DEPENDENCIES) \
+		$(TAGS_FILES) $(LISP)
+	tags=; \
+	here=`pwd`; \
+	list='$(SOURCES) $(HEADERS)  $(LISP) $(TAGS_FILES)'; \
+	unique=`for i in $$list; do \
+	    if test -f "$$i"; then echo $$i; else echo $(srcdir)/$$i; fi; \
+	  done | \
+	  $(AWK) '    { files[$$0] = 1; } \
+	       END { for (i in files) print i; }'`; \
+	test -z "$(CTAGS_ARGS)$$tags$$unique" \
+	  || $(CTAGS) $(CTAGSFLAGS) $(AM_CTAGSFLAGS) $(CTAGS_ARGS) \
+	     $$tags $$unique
+
+GTAGS:
+	here=`$(am__cd) $(top_builddir) && pwd` \
+	  && cd $(top_srcdir) \
+	  && gtags -i $(GTAGS_ARGS) $$here
+
+distclean-tags:
+	-rm -f TAGS ID GTAGS GRTAGS GSYMS GPATH tags
+
+distdir: $(DISTFILES)
+	@srcdirstrip=`echo "$(srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	topsrcdirstrip=`echo "$(top_srcdir)" | sed 's/[].[^$$\\*]/\\\\&/g'`; \
+	list='$(DISTFILES)'; \
+	  dist_files=`for file in $$list; do echo $$file; done | \
+	  sed -e "s|^$$srcdirstrip/||;t" \
+	      -e "s|^$$topsrcdirstrip/|$(top_builddir)/|;t"`; \
+	case $$dist_files in \
+	  */*) $(MKDIR_P) `echo "$$dist_files" | \
+			   sed '/\//!d;s|^|$(distdir)/|;s,/[^/]*$$,,' | \
+			   sort -u` ;; \
+	esac; \
+	for file in $$dist_files; do \
+	  if test -f $$file || test -d $$file; then d=.; else d=$(srcdir); fi; \
+	  if test -d $$d/$$file; then \
+	    dir=`echo "/$$file" | sed -e 's,/[^/]*$$,,'`; \
+	    if test -d $(srcdir)/$$file && test $$d != $(srcdir); then \
+	      cp -pR $(srcdir)/$$file $(distdir)$$dir || exit 1; \
+	    fi; \
+	    cp -pR $$d/$$file $(distdir)$$dir || exit 1; \
+	  else \
+	    test -f $(distdir)/$$file \
+	    || cp -p $$d/$$file $(distdir)/$$file \
+	    || exit 1; \
+	  fi; \
+	done
+check-am: all-am
+check: check-am
+all-am: Makefile $(LIBRARIES) $(LTLIBRARIES)
+installdirs:
+	for dir in "$(DESTDIR)$(pkgplugindir)"; do \
+	  test -z "$$dir" || $(MKDIR_P) "$$dir"; \
+	done
+install: install-am
+install-exec: install-exec-am
+install-data: install-data-am
+uninstall: uninstall-am
+
+install-am: all-am
+	@$(MAKE) $(AM_MAKEFLAGS) install-exec-am install-data-am
+
+installcheck: installcheck-am
+install-strip:
+	$(MAKE) $(AM_MAKEFLAGS) INSTALL_PROGRAM="$(INSTALL_STRIP_PROGRAM)" \
+	  install_sh_PROGRAM="$(INSTALL_STRIP_PROGRAM)" INSTALL_STRIP_FLAG=-s \
+	  `test -z '$(STRIP)' || \
+	    echo "INSTALL_PROGRAM_ENV=STRIPPROG='$(STRIP)'"` install
+mostlyclean-generic:
+
+clean-generic:
+
+distclean-generic:
+	-test -z "$(CONFIG_CLEAN_FILES)" || rm -f $(CONFIG_CLEAN_FILES)
+
+maintainer-clean-generic:
+	@echo "This command is intended for maintainers to use"
+	@echo "it deletes files that may require special tools to rebuild."
+clean: clean-am
+
+clean-am: clean-generic clean-libtool clean-noinstLIBRARIES \
+	clean-pkgpluginLTLIBRARIES mostlyclean-am
+
+distclean: distclean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+distclean-am: clean-am distclean-compile distclean-generic \
+	distclean-tags
+
+dvi: dvi-am
+
+dvi-am:
+
+html: html-am
+
+info: info-am
+
+info-am:
+
+install-data-am: install-pkgpluginLTLIBRARIES
+
+install-dvi: install-dvi-am
+
+install-exec-am:
+
+install-html: install-html-am
+
+install-info: install-info-am
+
+install-man:
+
+install-pdf: install-pdf-am
+
+install-ps: install-ps-am
+
+installcheck-am:
+
+maintainer-clean: maintainer-clean-am
+	-rm -rf ./$(DEPDIR)
+	-rm -f Makefile
+maintainer-clean-am: distclean-am maintainer-clean-generic
+
+mostlyclean: mostlyclean-am
+
+mostlyclean-am: mostlyclean-compile mostlyclean-generic \
+	mostlyclean-libtool
+
+pdf: pdf-am
+
+pdf-am:
+
+ps: ps-am
+
+ps-am:
+
+uninstall-am: uninstall-pkgpluginLTLIBRARIES
+
+.MAKE: install-am install-strip
+
+.PHONY: CTAGS GTAGS all all-am check check-am clean clean-generic \
+	clean-libtool clean-noinstLIBRARIES clean-pkgpluginLTLIBRARIES \
+	ctags distclean distclean-compile distclean-generic \
+	distclean-libtool distclean-tags distdir dvi dvi-am html \
+	html-am info info-am install install-am install-data \
+	install-data-am install-dvi install-dvi-am install-exec \
+	install-exec-am install-html install-html-am install-info \
+	install-info-am install-man install-pdf install-pdf-am \
+	install-pkgpluginLTLIBRARIES install-ps install-ps-am \
+	install-strip installcheck installcheck-am installdirs \
+	maintainer-clean maintainer-clean-generic mostlyclean \
+	mostlyclean-compile mostlyclean-generic mostlyclean-libtool \
+	pdf pdf-am ps ps-am tags uninstall uninstall-am \
+	uninstall-pkgpluginLTLIBRARIES
+
+# Tell versions [3.59,3.63) of GNU make to not export all variables.
+# Otherwise a system limit (for SysV at least) may be exceeded.
+.NOEXPORT:

=== added file 'plugin/hello_world/configure.in'
--- plugin/hello_world/configure.in	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/configure.in	2008-07-12 11:37:59 +0000
@@ -0,0 +1,7 @@
+AC_INIT(hello_world, 0.1)
+AM_INIT_AUTOMAKE
+AC_DISABLE_STATIC
+AC_PROG_LIBTOOL
+AC_CONFIG_FILES([Makefile])
+AC_OUTPUT
+

=== added file 'plugin/hello_world/hello_world.cc'
--- plugin/hello_world/hello_world.cc	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/hello_world.cc	2008-07-12 11:37:59 +0000
@@ -0,0 +1,104 @@
+/* Copyright (C) 2006 MySQL AB
+
+   This program is free software; you can redistribute it and/or modify
+   it under the terms of the GNU General Public License as published by
+   the Free Software Foundation; version 2 of the License.
+
+   This program is distributed in the hope that it will be useful,
+   but WITHOUT ANY WARRANTY; without even the implied warranty of
+   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+   GNU General Public License for more details.
+
+   You should have received a copy of the GNU General Public License
+   along with this program; if not, write to the Free Software
+   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA */
+
+#include <mysql_priv.h>
+#include <stdlib.h>
+#include <ctype.h>
+#include <drizzle_version.h>
+#include <mysql/plugin.h>
+#include <my_global.h>
+#include <my_dir.h>
+
+my_bool udf_init_hello_world(UDF_INIT *initid, UDF_ARGS *args, char *message)
+{
+  /* this is how to fail */
+  if (args->arg_count != 0)  {
+    strncpy(message, "Too many arguments", MYSQL_ERRMSG_SIZE);
+    return 1;
+  }
+
+  /* initid->ptr keeps state for between udf_init_foo and udf_deinit_foo */
+  initid->ptr= NULL;
+
+  return 0;
+}
+
+char *udf_doit_hello_world(UDF_INIT *initid, UDF_ARGS *args, char *result,
+			   unsigned long *length, char *is_null, char *error)
+{
+  /* "result" is preallocated 255 bytes for me, if i want to use it */
+  strncpy(result, "Hello, world!", 255);
+
+  /* if set to 255 or less, MySQL treats the result as a varchar
+     if set to greater than 255, MySQL treats the result as a blob */
+  *length= strlen("Hello, world!");
+
+  /* is_null is already zero, this is a demonstration */
+  *is_null= 0;
+
+  /* error is already zero, this is a demonstration */
+  *error= 0;
+
+  return result;
+}
+
+void udf_deinit_hello_world(UDF_INIT *initid)
+{
+  /* if we allocated initid->ptr, free it here */
+  return;
+}
+
+
+static int hello_world_plugin_init(void *p)
+{
+  udf_func *udff= (udf_func *) p;
+
+  udff->name.str= "hello_world";
+  udff->name.length= strlen("hello_world");
+  udff->type= UDFTYPE_FUNCTION;
+  udff->returns= STRING_RESULT;
+  udff->func_init= udf_init_hello_world;
+  udff->func_deinit= udf_deinit_hello_world;
+  udff->func= (Udf_func_any) udf_doit_hello_world;
+
+  return 0;
+}
+
+static int hello_world_plugin_deinit(void *p)
+{
+  udf_func *udff = (udf_func *) p;
+
+  return 0;
+}
+
+struct st_mysql_udf hello_world_plugin=
+{ MYSQL_UDF_INTERFACE_VERSION  };
+
+mysql_declare_plugin(hello_world)
+{
+  MYSQL_UDF_PLUGIN,
+  &hello_world_plugin,
+  "hello_world",
+  "Mark Atwood",
+  "Hello, world!",
+  PLUGIN_LICENSE_GPL,
+  hello_world_plugin_init, /* Plugin Init */
+  hello_world_plugin_deinit, /* Plugin Deinit */
+  0x0100,  /* 1.0 */
+  NULL,   /* status variables */
+  NULL,   /* system variables */
+  NULL    /* config options */
+}
+mysql_declare_plugin_end;

=== added file 'plugin/hello_world/plug.in'
--- plugin/hello_world/plug.in	1970-01-01 00:00:00 +0000
+++ plugin/hello_world/plug.in	2008-07-12 11:37:59 +0000
@@ -0,0 +1,3 @@
+MYSQL_PLUGIN(hello_world,[Daemon Example Plugin],
+        [UDF Plugin for Hello World.])
+MYSQL_PLUGIN_DYNAMIC(hello_world,   [libhello_world.la])

=== modified file 'server/Makefile.am'
--- server/Makefile.am	2008-07-11 10:33:22 +0000
+++ server/Makefile.am	2008-07-12 07:25:25 +0000
@@ -22,7 +22,8 @@
 pkgplugindir =		$(pkglibdir)/plugin
 AM_CPPFLAGS =		-I$(top_builddir)/include -I$(top_srcdir)/include \
 			-I$(srcdir) $(openssl_includes) \
-			$(libevent_includes)
+			$(libevent_includes) \
+			-ggdb
 SUBDIRS =		share
 libexec_PROGRAMS =	drizzled
 EXTRA_PROGRAMS =	gen_lex_hash

=== modified file 'server/drizzled.cc'
--- server/drizzled.cc	2008-07-11 15:49:04 +0000
+++ server/drizzled.cc	2008-07-12 07:25:25 +0000
@@ -2738,8 +2738,6 @@
     exit(1);
   }
 
-  udf_init();
-
   init_status_vars();
   if (opt_bootstrap) /* If running with bootstrap, do not start replication. */
     opt_skip_slave_start= 1;

=== modified file 'server/item_func.cc'
--- server/item_func.cc	2008-07-09 22:08:01 +0000
+++ server/item_func.cc	2008-07-12 07:25:25 +0000
@@ -2749,8 +2749,6 @@
 ** Rewritten by monty.
 ****************************************************************************/
 
-#ifdef HAVE_DLOPEN
-
 void udf_handler::cleanup()
 {
   if (!not_original)
@@ -2762,7 +2760,7 @@
         Udf_func_deinit deinit= u_d->func_deinit;
         (*deinit)(&initid);
       }
-      free_udf(u_d);
+
       initialized= false;
     }
     if (buffers)				// Because of bug in ecc
@@ -2802,7 +2800,6 @@
 	  sql_alloc(f_args.arg_count*sizeof(Item_result))))
 
     {
-      free_udf(u_d);
       return(true);
     }
     uint i;
@@ -2849,7 +2846,6 @@
 	!(f_args.attribute_lengths= (ulong*) sql_alloc(arg_count *
 						       sizeof(long))))
     {
-      free_udf(u_d);
       return(true);
     }
   }
@@ -2918,7 +2914,6 @@
     {
       my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
                u_d->name.str, init_msg_buff);
-      free_udf(u_d);
       return(true);
     }
     func->max_length=min(initid.max_length,MAX_BLOB_WIDTH);
@@ -3195,10 +3190,6 @@
   assert(not_original || !(initialized || buffers));
 }
 
-#else
-bool udf_handler::get_arguments() { return 0; }
-#endif /* HAVE_DLOPEN */
-
 /*
 ** User level locks
 */

=== modified file 'server/sql_plugin.cc'
--- server/sql_plugin.cc	2008-07-12 16:33:42 +0000
+++ server/sql_plugin.cc	2008-07-12 20:42:47 +0000
@@ -44,6 +44,9 @@
 extern int initialize_schema_table(st_plugin_int *plugin);
 extern int finalize_schema_table(st_plugin_int *plugin);
 
+extern int initialize_udf(st_plugin_int *plugin);
+extern int finalize_udf(st_plugin_int *plugin);
+
 /*
   The number of elements in both plugin_type_initialize and
   plugin_type_deinitialize should equal to the number of plugins
@@ -51,31 +54,29 @@
 */
 plugin_type_init plugin_type_initialize[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0,ha_initialize_handlerton,0,0,initialize_schema_table,
+  initialize_udf,ha_initialize_handlerton,0,0,initialize_schema_table,
   0
 };
 
 plugin_type_init plugin_type_deinitialize[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0,ha_finalize_handlerton,0,0,finalize_schema_table,
+  finalize_udf,ha_finalize_handlerton,0,0,finalize_schema_table,
   0
 };
 
-#ifdef HAVE_DLOPEN
 static const char *plugin_interface_version_sym=
                    "_mysql_plugin_interface_version_";
 static const char *sizeof_st_plugin_sym=
                    "_mysql_sizeof_struct_st_plugin_";
 static const char *plugin_declarations_sym= "_mysql_plugin_declarations_";
 static int min_plugin_interface_version= MYSQL_PLUGIN_INTERFACE_VERSION & ~0xFF;
-#endif
 
 /* Note that 'int version' must be the first field of every plugin
    sub-structure (plugin->info).
 */
 static int min_plugin_info_interface_version[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0x0000,
+  MYSQL_UDF_INTERFACE_VERSION,
   MYSQL_HANDLERTON_INTERFACE_VERSION,
   MYSQL_FTPARSER_INTERFACE_VERSION,
   MYSQL_DAEMON_INTERFACE_VERSION,
@@ -84,7 +85,7 @@
 };
 static int cur_plugin_info_interface_version[MYSQL_MAX_PLUGIN_TYPE_NUM]=
 {
-  0x0000, /* UDF: not implemented */
+  MYSQL_UDF_INTERFACE_VERSION,
   MYSQL_HANDLERTON_INTERFACE_VERSION,
   MYSQL_FTPARSER_INTERFACE_VERSION,
   MYSQL_DAEMON_INTERFACE_VERSION,
@@ -267,8 +268,6 @@
   Plugin support code
 ****************************************************************************/
 
-#ifdef HAVE_DLOPEN
-
 static struct st_plugin_dl *plugin_dl_find(const LEX_STRING *dl)
 {
   uint i;
@@ -285,7 +284,6 @@
   return(0);
 }
 
-
 static st_plugin_dl *plugin_dl_insert_or_reuse(struct st_plugin_dl *plugin_dl)
 {
   uint i;
@@ -307,15 +305,11 @@
                                            sizeof(struct st_plugin_dl));
   return(tmp);
 }
-#endif /* HAVE_DLOPEN */
-
 
 static inline void free_plugin_mem(struct st_plugin_dl *p)
 {
-#ifdef HAVE_DLOPEN
   if (p->handle)
     dlclose(p->handle);
-#endif
   my_free(p->dl.str, MYF(MY_ALLOW_ZERO_PTR));
   if (p->version != MYSQL_PLUGIN_INTERFACE_VERSION)
     my_free((uchar*)p->plugins, MYF(MY_ALLOW_ZERO_PTR));

=== modified file 'server/sql_udf.cc'
--- server/sql_udf.cc	2008-07-09 16:33:52 +0000
+++ server/sql_udf.cc	2008-07-12 07:25:25 +0000
@@ -18,13 +18,6 @@
 /*
    Known bugs:
   
-   Memory for functions is never freed!
-   Shared libraries are not closed before mysqld exits;
-     - This is because we can't be sure if some threads are using
-       a function.
-  
-   The bugs only affect applications that create and free a lot of
-   dynamic functions, so this shouldn't be a real problem.
 */
 
 #ifdef USE_PRAGMA_IMPLEMENTATION
@@ -34,451 +27,121 @@
 #include "mysql_priv.h"
 #include <my_pthread.h>
 
-#ifdef HAVE_DLOPEN
 extern "C"
 {
 #include <stdarg.h>
 #include <hash.h>
 }
 
-static bool initialized = 0;
+static bool udf_startup= false; /* We do not lock because startup is single threaded */
 static MEM_ROOT mem;
 static HASH udf_hash;
-static rw_lock_t THR_LOCK_udf;
-
 
 static udf_func *add_udf(LEX_STRING *name, Item_result ret,
                          char *dl, Item_udftype typ);
 static void del_udf(udf_func *udf);
-static void *find_udf_dl(const char *dl);
-
-static char *init_syms(udf_func *tmp, char *nm)
-{
-  char *end;
-
-  if (!((tmp->func= (Udf_func_any) dlsym(tmp->dlhandle, tmp->name.str))))
-    return tmp->name.str;
-
-  end=strmov(nm,tmp->name.str);
-
-  if (tmp->type == UDFTYPE_AGGREGATE)
-  {
-    (void)strmov(end, "_clear");
-    if (!((tmp->func_clear= (Udf_func_clear) dlsym(tmp->dlhandle, nm))))
-      return nm;
-    (void)strmov(end, "_add");
-    if (!((tmp->func_add= (Udf_func_add) dlsym(tmp->dlhandle, nm))))
-      return nm;
-  }
-
-  (void) strmov(end,"_deinit");
-  tmp->func_deinit= (Udf_func_deinit) dlsym(tmp->dlhandle, nm);
-
-  (void) strmov(end,"_init");
-  tmp->func_init= (Udf_func_init) dlsym(tmp->dlhandle, nm);
-
-  /*
-    to prefent loading "udf" from, e.g. libc.so
-    let's ensure that at least one auxiliary symbol is defined
-  */
-  if (!tmp->func_init && !tmp->func_deinit && tmp->type != UDFTYPE_AGGREGATE)
-    return nm;
-  return 0;
-}
-
 
 extern "C" uchar* get_hash_key(const uchar *buff, size_t *length,
 			      my_bool not_used __attribute__((unused)))
 {
-  udf_func *udf=(udf_func*) buff;
-  *length=(uint) udf->name.length;
+  udf_func *udf= (udf_func*) buff;
+  *length= (uint) udf->name.length;
   return (uchar*) udf->name.str;
 }
 
 
-/*
-  Read all predeclared functions from mysql.func and accept all that
-  can be used.
-*/
-
 void udf_init()
 {
-  TABLE_LIST tables;
-
-  if (initialized)
-    return;
-
-  my_rwlock_init(&THR_LOCK_udf,NULL);
-
   init_sql_alloc(&mem, UDF_ALLOC_BLOCK_SIZE, 0);
-  THD *new_thd = new THD;
-  if (!new_thd ||
-      hash_init(&udf_hash,system_charset_info,32,0,0,get_hash_key, NULL, 0))
+
+  if (hash_init(&udf_hash, system_charset_info, 32, 0, 0, get_hash_key, NULL, 0))
   {
     sql_print_error("Can't allocate memory for udf structures");
     hash_free(&udf_hash);
-    free_root(&mem,MYF(0));
-    delete new_thd;
+    free_root(&mem, MYF(0));
     return;
   }
-
-  initialized = 1;
-  close_thread_tables(new_thd);
-  delete new_thd;
-  /* Remember that we don't have a THD */
-  my_pthread_setspecific_ptr(THR_THD,  0);
-  return;
 }
 
-
+/* called by mysqld.cc clean_up() */
 void udf_free()
 {
-  /* close all shared libraries */
-  
-  for (uint idx=0 ; idx < udf_hash.records ; idx++)
-  {
-    udf_func *udf=(udf_func*) hash_element(&udf_hash,idx);
-    if (udf->dlhandle)				// Not closed before
-    {
-      /* Mark all versions using the same handler as closed */
-      for (uint j=idx+1 ;  j < udf_hash.records ; j++)
-      {
-	udf_func *tmp=(udf_func*) hash_element(&udf_hash,j);
-	if (udf->dlhandle == tmp->dlhandle)
-	  tmp->dlhandle=0;			// Already closed
-      }
-      dlclose(udf->dlhandle);
-    }
-  }
   hash_free(&udf_hash);
-  free_root(&mem,MYF(0));
-  if (initialized)
-  {
-    initialized= 0;
-    rwlock_destroy(&THR_LOCK_udf);
-  }
-  return;
-}
-
-
-static void del_udf(udf_func *udf)
-{
-  
-  if (!--udf->usage_count)
-  {
-    hash_delete(&udf_hash,(uchar*) udf);
-    using_udf_functions=udf_hash.records != 0;
-  }
-  else
-  {
-    /*
-      The functions is in use ; Rename the functions instead of removing it.
-      The functions will be automaticly removed when the least threads
-      doesn't use it anymore
-    */
-    char *name= udf->name.str;
-    uint name_length=udf->name.length;
-    udf->name.str=(char*) "*";
-    udf->name.length=1;
-    hash_update(&udf_hash,(uchar*) udf,(uchar*) name,name_length);
-  }
-  return;
-}
-
-
-void free_udf(udf_func *udf)
-{
-  
-  
-  if (!initialized)
-    return;
-
-  rw_wrlock(&THR_LOCK_udf);
-  if (!--udf->usage_count)
-  {
-    /*
-      We come here when someone has deleted the udf function
-      while another thread still was using the udf
-    */
-    hash_delete(&udf_hash,(uchar*) udf);
-    using_udf_functions=udf_hash.records != 0;
-    if (!find_udf_dl(udf->dl))
-      dlclose(udf->dlhandle);
-  }
-  rw_unlock(&THR_LOCK_udf);
-  return;
-}
-
+  free_root(&mem, MYF(0));
+}
 
 /* This is only called if using_udf_functions != 0 */
-
-udf_func *find_udf(const char *name,uint length,bool mark_used)
-{
-  udf_func *udf=0;
-  
-
-  if (!initialized)
-    return(NULL);
-
-  /* TODO: This should be changed to reader locks someday! */
-  if (mark_used)
-    rw_wrlock(&THR_LOCK_udf);  /* Called during fix_fields */
-  else
-    rw_rdlock(&THR_LOCK_udf);  /* Called during parsing */
-
-  if ((udf=(udf_func*) hash_search(&udf_hash,(uchar*) name,
-				   length ? length : (uint) strlen(name))))
-  {
-    if (!udf->dlhandle)
-      udf=0;					// Could not be opened
-    else if (mark_used)
-      udf->usage_count++;
-  }
-  rw_unlock(&THR_LOCK_udf);
-  return(udf);
-}
-
-
-static void *find_udf_dl(const char *dl)
-{
-  
-
-  /*
-    Because only the function name is hashed, we have to search trough
-    all rows to find the dl.
-  */
-  for (uint idx=0 ; idx < udf_hash.records ; idx++)
-  {
-    udf_func *udf=(udf_func*) hash_element(&udf_hash,idx);
-    if (!strcmp(dl, udf->dl) && udf->dlhandle != NULL)
-      return(udf->dlhandle);
-  }
-  return(0);
-}
-
-
-/* Assume that name && dl is already allocated */
-
-static udf_func *add_udf(LEX_STRING *name, Item_result ret, char *dl,
-			 Item_udftype type)
-{
-  if (!name || !dl || !(uint) type || (uint) type > (uint) UDFTYPE_AGGREGATE)
-    return 0;
-  udf_func *tmp= (udf_func*) alloc_root(&mem, sizeof(udf_func));
-  if (!tmp)
-    return 0;
-  bzero((char*) tmp,sizeof(*tmp));
-  tmp->name = *name; //dup !!
-  tmp->dl = dl;
-  tmp->returns = ret;
-  tmp->type = type;
-  tmp->usage_count=1;
-  if (my_hash_insert(&udf_hash,(uchar*)  tmp))
-    return 0;
-  using_udf_functions=1;
-  return tmp;
-}
-
-
-/**
-  Create a user defined function. 
-
-  @note Like implementations of other DDL/DML in MySQL, this function
-  relies on the caller to close the thread tables. This is done in the
-  end of dispatch_command().
-*/
-
-int mysql_create_function(THD *thd,udf_func *udf)
-{
-  int error;
-  void *dl=0;
-  bool new_dl=0;
-  TABLE *table;
-  TABLE_LIST tables;
-  udf_func *u_d;
-  
-
-  if (!initialized)
-  {
-    if (opt_noacl)
-      my_error(ER_CANT_INITIALIZE_UDF, MYF(0),
-               udf->name.str,
-               "UDFs are unavailable with the --skip-grant-tables option");
-    else
-      my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
-    return(1);
-  }
-
-  /*
-    Ensure that the .dll doesn't have a path
-    This is done to ensure that only approved dll from the system
-    directories are used (to make this even remotely secure).
-
-    On windows we must check both FN_LIBCHAR and '/'.
-  */
-  if (my_strchr(files_charset_info, udf->dl,
-                udf->dl + strlen(udf->dl), FN_LIBCHAR) ||
-      IF_WIN(my_strchr(files_charset_info, udf->dl,
-                       udf->dl + strlen(udf->dl), '/'), 0))
-  {
-    my_message(ER_UDF_NO_PATHS, ER(ER_UDF_NO_PATHS), MYF(0));
-    return(1);
-  }
-  if (check_identifier_name(&udf->name, ER_TOO_LONG_IDENT))
-    return(1);
-
-  /* 
-    Turn off row binlogging of this statement and use statement-based 
-    so that all supporting tables are updated for CREATE FUNCTION command.
-  */
-  if (thd->current_stmt_binlog_row_based)
-    thd->clear_current_stmt_binlog_row_based();
-
-  rw_wrlock(&THR_LOCK_udf);
-  if ((hash_search(&udf_hash,(uchar*) udf->name.str, udf->name.length)))
-  {
-    my_error(ER_UDF_EXISTS, MYF(0), udf->name.str);
-    goto err;
-  }
-  if (!(dl = find_udf_dl(udf->dl)))
-  {
-    char dlpath[FN_REFLEN];
-    strxnmov(dlpath, sizeof(dlpath) - 1, opt_plugin_dir, "/", udf->dl, NullS);
-    if (!(dl = dlopen(dlpath, RTLD_NOW)))
-    {
-      my_error(ER_CANT_OPEN_LIBRARY, MYF(0),
-               udf->dl, errno, dlerror());
-      goto err;
-    }
-    new_dl=1;
-  }
-  udf->dlhandle=dl;
-  {
-    char buf[NAME_LEN+16], *missing;
-    if ((missing= init_syms(udf, buf)))
-    {
-      my_error(ER_CANT_FIND_DL_ENTRY, MYF(0), missing);
-      goto err;
-    }
-  }
-  udf->name.str=strdup_root(&mem,udf->name.str);
-  udf->dl=strdup_root(&mem,udf->dl);
-  if (!(u_d=add_udf(&udf->name,udf->returns,udf->dl,udf->type)))
-    goto err;
-  u_d->dlhandle = dl;
-  u_d->func=udf->func;
-  u_d->func_init=udf->func_init;
-  u_d->func_deinit=udf->func_deinit;
-  u_d->func_clear=udf->func_clear;
-  u_d->func_add=udf->func_add;
-
-  /* create entry in mysql.func table */
-
-  bzero((char*) &tables,sizeof(tables));
-  tables.db= (char*) "mysql";
-  tables.table_name= tables.alias= (char*) "func";
-  /* Allow creation of functions even if we can't open func table */
-  if (!(table = open_ltable(thd, &tables, TL_WRITE, 0)))
-    goto err;
-  table->use_all_columns();
-  restore_record(table, s->default_values);	// Default values for fields
-  table->field[0]->store(u_d->name.str, u_d->name.length, system_charset_info);
-  table->field[1]->store((longlong) u_d->returns, TRUE);
-  table->field[2]->store(u_d->dl,(uint) strlen(u_d->dl), system_charset_info);
-  if (table->s->fields >= 4)			// If not old func format
-    table->field[3]->store((longlong) u_d->type, TRUE);
-  error = table->file->ha_write_row(table->record[0]);
-
-  if (error)
-  {
-    my_error(ER_ERROR_ON_WRITE, MYF(0), "mysql.func", error);
-    del_udf(u_d);
-    goto err;
-  }
-  rw_unlock(&THR_LOCK_udf);
-
-  /* Binlog the create function. */
-  write_bin_log(thd, TRUE, thd->query, thd->query_length);
-
-  return(0);
-
- err:
-  if (new_dl)
-    dlclose(dl);
-  rw_unlock(&THR_LOCK_udf);
-  return(1);
-}
-
-
-int mysql_drop_function(THD *thd,const LEX_STRING *udf_name)
-{
-  TABLE *table;
-  TABLE_LIST tables;
+udf_func *find_udf(const char *name, uint length, bool mark_used)
+{
   udf_func *udf;
-  char *exact_name_str;
-  uint exact_name_len;
+
+  if (udf_startup == false)
+    return NULL;
+
+  udf= (udf_func*) hash_search(&udf_hash,
+                               (uchar*) name,
+                               length ? length : (uint) strlen(name));
+
+  return (udf);
+}
+
+static bool add_udf(udf_func *udf)
+{
+  if (my_hash_insert(&udf_hash, (uchar*) udf))
+    return false;
+
+  using_udf_functions= 1;
+
+  return true;
+}
+
+int initialize_udf(st_plugin_int *plugin)
+{
+  udf_func *udff;
+
+  if (udf_startup == false)
+  {
+    udf_init();
+    udf_startup= true;
+  }
+	  
+  /* allocate the udf_func structure */
+  udff = (udf_func *)my_malloc(sizeof(udf_func), MYF(MY_WME | MY_ZEROFILL));
+  if (udff == NULL) return 1;
+
+  plugin->data= (void *)udff;
+
+  if (plugin->plugin->init)
+  {
+    /* todo, if the plugin doesnt have an init, bail out */
+
+    if (plugin->plugin->init((void *)udff))
+    {
+      sql_print_error("Plugin '%s' init function returned error.",
+                      plugin->name.str);
+      goto err;
+    }
+  }
   
-
-  if (!initialized)
-  {
-    if (opt_noacl)
-      my_error(ER_FUNCTION_NOT_DEFINED, MYF(0), udf_name->str);
-    else
-      my_message(ER_OUT_OF_RESOURCES, ER(ER_OUT_OF_RESOURCES), MYF(0));
-    return(1);
-  }
-
-  /* 
-    Turn off row binlogging of this statement and use statement-based
-    so that all supporting tables are updated for DROP FUNCTION command.
-  */
-  if (thd->current_stmt_binlog_row_based)
-    thd->clear_current_stmt_binlog_row_based();
-
-  rw_wrlock(&THR_LOCK_udf);  
-  if (!(udf=(udf_func*) hash_search(&udf_hash,(uchar*) udf_name->str,
-				    (uint) udf_name->length)))
-  {
-    my_error(ER_FUNCTION_NOT_DEFINED, MYF(0), udf_name->str);
-    goto err;
-  }
-  exact_name_str= udf->name.str;
-  exact_name_len= udf->name.length;
-  del_udf(udf);
-  /*
-    Close the handle if this was function that was found during boot or
-    CREATE FUNCTION and it's not in use by any other udf function
-  */
-  if (udf->dlhandle && !find_udf_dl(udf->dl))
-    dlclose(udf->dlhandle);
-
-  bzero((char*) &tables,sizeof(tables));
-  tables.db=(char*) "mysql";
-  tables.table_name= tables.alias= (char*) "func";
-  if (!(table = open_ltable(thd, &tables, TL_WRITE, 0)))
-    goto err;
-  table->use_all_columns();
-  table->field[0]->store(exact_name_str, exact_name_len, &my_charset_bin);
-  if (!table->file->index_read_idx_map(table->record[0], 0,
-                                       (uchar*) table->field[0]->ptr,
-                                       HA_WHOLE_KEY,
-                                       HA_READ_KEY_EXACT))
-  {
-    int error;
-    if ((error = table->file->ha_delete_row(table->record[0])))
-      table->file->print_error(error, MYF(0));
-  }
-  close_thread_tables(thd);
-
-  rw_unlock(&THR_LOCK_udf);
-
-  /* Binlog the drop function. */
-  write_bin_log(thd, TRUE, thd->query, thd->query_length);
-
-  return(0);
- err:
-  rw_unlock(&THR_LOCK_udf);
-  return(1);
-}
-
-#endif /* HAVE_DLOPEN */
+  add_udf(udff);
+
+  return 0;
+err:
+  my_free(udff, MYF(0));
+  return 1;
+}
+
+int finalize_udf(st_plugin_int *plugin)
+{ 
+  udf_func *udff = (udf_func *)plugin->data;
+
+  /* TODO: Issue warning on failure */
+  if (udff && plugin->plugin->deinit)
+    (void)plugin->plugin->deinit(udff);
+
+  if (udff)
+    my_free(udff, MYF(0));
+
+  return 0;
+}
+

=== modified file 'server/sql_udf.h'
--- server/sql_udf.h	2008-07-07 14:25:25 +0000
+++ server/sql_udf.h	2008-07-12 07:25:25 +0000
@@ -36,14 +36,12 @@
   LEX_STRING name;
   Item_result returns;
   Item_udftype type;
-  char *dl;
-  void *dlhandle;
   Udf_func_any func;
   Udf_func_init func_init;
   Udf_func_deinit func_deinit;
   Udf_func_clear func_clear;
   Udf_func_add func_add;
-  ulong usage_count;
+  void *data;
 } udf_func;
 
 class Item_result_field;
@@ -133,10 +131,7 @@
 };
 
 
-#ifdef HAVE_DLOPEN
 void udf_init(void),udf_free(void);
 udf_func *find_udf(const char *name, uint len=0,bool mark_used=0);
 void free_udf(udf_func *udf);
 int mysql_create_function(THD *thd,udf_func *udf);
-int mysql_drop_function(THD *thd,const LEX_STRING *name);
-#endif

=== modified file 'server/sql_yacc.yy'
--- server/sql_yacc.yy	2008-07-10 21:15:26 +0000
+++ server/sql_yacc.yy	2008-07-12 07:25:25 +0000
@@ -3797,7 +3797,6 @@
 function_call_generic:
           IDENT_sys '('
           {
-#ifdef HAVE_DLOPEN
             udf_func *udf= 0;
             LEX *lex= Lex;
             if (using_udf_functions &&
@@ -3812,7 +3811,6 @@
             }
             /* Temporary placing the result of find_udf in $3 */
             $<udf>$= udf;
-#endif
           }
           opt_udf_expr_list ')'
           {
@@ -3836,10 +3834,9 @@
             }
             else
             {
-#ifdef HAVE_DLOPEN
               /* Retrieving the result of find_udf */
               udf_func *udf= $<udf>3;
-
+              if (udf)
               {
                 if (udf->type == UDFTYPE_AGGREGATE)
                 {
@@ -3848,7 +3845,6 @@
 
                 item= Create_udf_func::s_singleton.create(thd, udf, $4);
               }
-#endif
             }
 
             if (! ($$= item))

